/*
 * 02.02 -- timers with interrupts
 * for miniPICkit by z0r0 & res
 *
 * kit connection:
 *  GP0: LED0 (red)
 *  GP1: LED1 (green)
 *  GP2: BTN0 (via jumper J1) + extension header
 *  GP4,5: extension header
 */

#include <htc.h>

// fuses
__CONFIG(MCLRE_OFF & WDTE_OFF & FOSC_INTRCIO);

// local defines
#define DELAY 0x90

/** =================================================================================
*   =================================================================================
*
*    tc_int() interrupt service routine
*
*/

volatile char speed = 0;

void interrupt tc_int(void){

        // TMR1
        if(TMR1IF == 1){
            GPIO = ~GPIO;
            TMR1H = speed * 0x30;
            TMR1IF = 0;
        }

	// that's all..
	GIE = 1;
	return;
}

/*
 * main ()
 */
void main(void) {
    int cntr = 0;
    unsigned char b1processed = 0;

    /* init */
    // gp
    CMCON = 7;      // disable comparator
    ANSEL = 0;      // disble analog functions
    TRISIO = 0;     // set all pins as output
    TRISIO2 = 1;      // set GP2 as input


    // timer 1
    TMR1CS = 0;     // set internal clocks as clock source
    T1CONbits.T1CKPS = 0b11;    // set prescaler to 1:8
    TMR1ON = 1;
    TMR1IF = 0;     // enable tmr1 interrupt
    TMR1IE = 1;

    // interrupts
    PEIE = 1;       // peripheral interrupt enable
    GIE = 1;        // global interrupt enable

    //

    /* main program */
    GPIO = 0b01;

    /* main loop */
    while (1){
        if(GPIO2 == 0 && b1processed == 0){
            cntr = 0x500;
            while(--cntr);
            if(GPIO2 == 0){
                speed ++;
                speed = speed & 0b11;
                b1processed = 1;
            }
        }
        if(GPIO2 == 1){
            b1processed = 0;
        }
    }
}




